=== debian/changelog ===
hipercontracer (2.1.10-1ubuntu1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 25 Feb 2026 13:48:27 +0100

hipercontracer (2.1.9-1ubuntu1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Removed obsolete libboost-system-dev dependency
    (Closes: #1127210).
  * debian/control: Updated Debian standards version.
  * debian/control: Updated standards version to 4.7.3.

 -- Thomas Dreibholz <dreibh@simula.no>  Mon, 09 Feb 2026 15:19:39 +0100

hipercontracer (2.1.8-1ubuntu1) unstable; urgency=medium

  * New upstream release.
  * debian/*: Adapted the packaging, according to the tools description
    in https://github.com/dreibh/hipercontracer/blob/master/README.md .
    The split into sub-packages allows one to install a subset of the
    HiPerConTracer tools, with their dependencies, without installing
    the whole framework and all of its dependencies.

 -- Thomas Dreibholz <dreibh@simula.no>  Tue, 09 Dec 2025 16:46:41 +0100

hipercontracer (2.1.7-1ubuntu1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Removed Vcs-* fields.
  * debian/*.install: usr/lib/*/ -> usr/lib/${DEB_HOST_MULTIARCH}/.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 26 Nov 2025 16:18:10 +0100

hipercontracer (2.1.6-1ubuntu1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 21 Nov 2025 15:48:09 +0100

hipercontracer (2.1.5-1ubuntu1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 19 Nov 2025 12:40:20 +0100

hipercontracer (2.1.4-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 14 Nov 2025 11:08:35 +0100

hipercontracer (2.1.3-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 24 Oct 2025 12:20:23 +0200

hipercontracer (2.1.2-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Thu, 23 Oct 2025 17:19:39 +0200

hipercontracer (2.1.1-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Sun, 21 Sep 2025 17:58:40 +0200

hipercontracer (2.1.0-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 18 Jun 2025 15:38:57 +0200

hipercontracer (2.0.17-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Thu, 05 Jun 2025 08:57:02 +0200

hipercontracer (2.0.16-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 14 May 2025 11:44:51 +0200

hipercontracer (2.0.15-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Mon, 12 May 2025 22:50:03 +0200

hipercontracer (2.0.14-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Sun, 27 Apr 2025 20:49:05 +0200

hipercontracer (2.0.13-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 16 Apr 2025 08:52:12 +0200

hipercontracer (2.0.12-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Tue, 15 Apr 2025 13:00:16 +0200

hipercontracer (2.0.11-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 11 Apr 2025 16:19:44 +0200

hipercontracer (2.0.10-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Thu, 10 Apr 2025 11:39:30 +0200

hipercontracer (2.0.9-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Tue, 08 Apr 2025 17:38:09 +0200

hipercontracer (2.0.8-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 04 Apr 2025 16:04:12 +0200

hipercontracer (2.0.7-1ubuntu1) noble; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.7.2.

 -- Thomas Dreibholz <dreibh@simula.no>  Thu, 03 Apr 2025 11:51:36 +0200

hipercontracer (2.0.6-1ubuntu1) noble; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.7.1.

 -- Thomas Dreibholz <dreibh@simula.no>  Mon, 31 Mar 2025 15:51:05 +0200

hipercontracer (2.0.5-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Mon, 17 Feb 2025 19:14:51 +0100

hipercontracer (2.0.4-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Sun, 16 Feb 2025 11:52:23 +0100

hipercontracer (2.0.3-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Sun, 16 Feb 2025 11:00:11 +0100

hipercontracer (2.0.2-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 29 Jan 2025 16:34:39 +0100

hipercontracer (2.0.1-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Tue, 28 Jan 2025 16:41:15 +0100

hipercontracer (2.0.0-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 20 Dec 2024 13:37:08 +0100

hipercontracer (1.6.10-1ubuntu1) jammy; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <thomas.dreibholz@gmail.com>  Wed, 06 Dec 2023 16:54:11 +0100

hipercontracer (1.6.9-1ubuntu1) jammy; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <thomas.dreibholz@gmail.com>  Thu, 21 Sep 2023 17:13:31 +0200

hipercontracer (1.6.8-1ubuntu1) jammy; urgency=medium

  * New upstream release.
  * Build fix for recent BOOST versions (Closes: #1029783).

 -- Thomas Dreibholz <thomas.dreibholz@gmail.com>  Tue, 18 Apr 2023 21:09:46 +0200

hipercontracer (1.6.7-1ubuntu1) jammy; urgency=medium

  * New upstream release.

